
package net.mcreator.geafm.network;

import net.neoforged.neoforge.network.handling.PlayPayloadContext;
import net.neoforged.fml.event.lifecycle.FMLCommonSetupEvent;
import net.neoforged.fml.common.Mod;
import net.neoforged.bus.api.SubscribeEvent;

import net.minecraft.world.level.Level;
import net.minecraft.world.entity.player.Player;
import net.minecraft.resources.ResourceLocation;
import net.minecraft.network.protocol.common.custom.CustomPacketPayload;
import net.minecraft.network.protocol.PacketFlow;
import net.minecraft.network.chat.Component;
import net.minecraft.network.FriendlyByteBuf;
import net.minecraft.core.BlockPos;

import net.mcreator.geafm.world.inventory.UpgradeSystemMenu;
import net.mcreator.geafm.procedures.OpenPotionUTProcedure;
import net.mcreator.geafm.procedures.OpenMiscUTProcedure;
import net.mcreator.geafm.procedures.OpenCombatUTProcedure;
import net.mcreator.geafm.procedures.OpenAscensionUTProcedure;
import net.mcreator.geafm.GeafmMod;

import java.util.HashMap;

@Mod.EventBusSubscriber(bus = Mod.EventBusSubscriber.Bus.MOD)
public record UpgradeSystemButtonMessage(int buttonID, int x, int y, int z) implements CustomPacketPayload {

	public static final ResourceLocation ID = new ResourceLocation(GeafmMod.MODID, "upgrade_system_buttons");
	public UpgradeSystemButtonMessage(FriendlyByteBuf buffer) {
		this(buffer.readInt(), buffer.readInt(), buffer.readInt(), buffer.readInt());
	}

	@Override
	public void write(final FriendlyByteBuf buffer) {
		buffer.writeInt(buttonID);
		buffer.writeInt(x);
		buffer.writeInt(y);
		buffer.writeInt(z);
	}

	@Override
	public ResourceLocation id() {
		return ID;
	}

	public static void handleData(final UpgradeSystemButtonMessage message, final PlayPayloadContext context) {
		if (context.flow() == PacketFlow.SERVERBOUND) {
			context.workHandler().submitAsync(() -> {
				Player entity = context.player().get();
				int buttonID = message.buttonID;
				int x = message.x;
				int y = message.y;
				int z = message.z;
				handleButtonAction(entity, buttonID, x, y, z);
			}).exceptionally(e -> {
				context.packetHandler().disconnect(Component.literal(e.getMessage()));
				return null;
			});
		}
	}

	public static void handleButtonAction(Player entity, int buttonID, int x, int y, int z) {
		Level world = entity.level();
		HashMap guistate = UpgradeSystemMenu.guistate;
		// security measure to prevent arbitrary chunk generation
		if (!world.hasChunkAt(new BlockPos(x, y, z)))
			return;
		if (buttonID == 0) {

			OpenAscensionUTProcedure.execute(world, x, y, z, entity);
		}
		if (buttonID == 1) {

			OpenCombatUTProcedure.execute(world, x, y, z, entity);
		}
		if (buttonID == 2) {

			OpenPotionUTProcedure.execute(world, x, y, z, entity);
		}
		if (buttonID == 3) {

			OpenMiscUTProcedure.execute(world, x, y, z, entity);
		}
	}

	@SubscribeEvent
	public static void registerMessage(FMLCommonSetupEvent event) {
		GeafmMod.addNetworkMessage(UpgradeSystemButtonMessage.ID, UpgradeSystemButtonMessage::new, UpgradeSystemButtonMessage::handleData);
	}
}
